# 《HelloGitHub》第 03 期
>兴趣是最好的老师，**HelloGitHub** 就是帮你找到兴趣！
<p align="center">
    <img src='https://raw.githubusercontent.com/521xueweihan/img/master/hellogithub/01/img/hello-github.jpg' style="max-width:100%;"></img>
</p>

## 简介
分享 GitHub 上有趣、入门级的开源项目。

这是一个面向**编程新手**、**热爱编程**、**对开源社区感兴趣** 人群的月刊，月刊的内容包括：**各种编程语言的项目**、**让生活变得更美好的工具**、**书籍、学习笔记、教程等**，这些开源项目大多都是非常容易上手，而且非常 Cool。主要是希望大家能动手用起来，加入到**开源社区**中。
- 会编程的可以贡献代码
- 不会编程的可以反馈使用这些工具中的 Bug
- 帮着宣传你觉得优秀的项目
- Star 项目⭐️

在浏览、参与这些项目的过程中，你将学习到**更多编程知识**、**提高编程技巧**、**找到编程的乐趣**。

🎉 最后 HelloGitHub 这个项目就诞生了 🎉

## 目录
- [CSS 项目](#CSS-项目)
- [Go 项目](#Go-项目)
- [Java 项目](#Java-项目)
- [JavaScript 项目](#JavaScript-项目)
- [PHP 项目](#PHP-项目)
- [Python 项目](#Python-项目)
- [其它](#其它)


<p align="center">
  <img src="https://raw.githubusercontent.com/521xueweihan/img/master/hellogithub/logo/weixin.png" style="max-width:30%;"></img><br>
欢迎关注 HelloGitHub 公众号，获取更多开源项目的资料和内容。
</p>

## 内容
> **以下为本期内容**｜每个月 **28** 号发布最新一期｜[官网](https://hellogithub.com/)

### CSS 项目
1、[animate.css](https://hellogithub.com/periodical/statistics/click/?target=https://github.com/daneden/animate.css)：提供炫酷动画效果，同时方便、易用、跨浏览器的 CSS 库。[在线演示](https://daneden.github.io/animate.css/)

2、[mui](https://hellogithub.com/periodical/statistics/click/?target=https://github.com/dcloudio/mui)：最接近原生 APP 体验的高性能框架。性能和体验的差距，一直是 mobile App 开发者放弃 HTML5 的首要原因。mui 框架有效的解决了这些问题，这是一个可以方便开发出高性能 App 的框架，也是目前最接近原生 App 效果的框架。[mui 官网](http://dev.dcloud.net.cn/mui/)

<p align="center"><a href="#目录">🔙 返回目录 🔙</a></p><br>

### Go 项目
3、[pholcus](https://hellogithub.com/periodical/statistics/click/?target=https://github.com/henrylee2cn/pholcus)：Pholcus 是 Go 写的重量级爬虫，纯 Go 语言编写的高并发、分布式、重量级爬虫软件，支持单机、服务端、客户端三种运行模式，拥有 Web、GUI、命令行三种操作界面，功能齐全、强大。[使用手册](https://pholcus.gitbooks.io/docs/content/)，使用展示如图：


<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img/master/hellogithub/03/img/Pholcus-min.jpg' style="max-width:80%; max-height=80%;"></img></p>

<p align="center"><a href="#目录">🔙 返回目录 🔙</a></p><br>

### Java 项目
4、[greys-anatomy](https://hellogithub.com/periodical/statistics/click/?target=https://github.com/oldmanpushcart/greys-anatomy)：Greys 是 Java 在线问题诊断工具。

<p align="center"><a href="#目录">🔙 返回目录 🔙</a></p><br>

### JavaScript 项目
5、[OS.js](https://hellogithub.com/periodical/statistics/click/?target=https://github.com/os-js/OS.js)：JavaScript 写的基于浏览器上的桌面操作系统。[在线演示](https://demo.os-js.org/)，使用展示如图：


<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img/master/hellogithub/03/img/os-js-min.png' style="max-width:80%; max-height=80%;"></img></p>

6、[editor.md](https://hellogithub.com/periodical/statistics/click/?target=https://github.com/pandao/editor.md)：是一款开源的、可嵌入的 Markdown 在线编辑器（组件），基于 CodeMirror、jQuery 和 Marked 构建。[在线尝试](http://lab.lepture.com/editor/)，使用展示如图：


<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img/master/hellogithub/03/img/editor.md-min.png' style="max-width:80%; max-height=80%;"></img></p>

<p align="center"><a href="#目录">🔙 返回目录 🔙</a></p><br>

### PHP 项目
7、[walle-web](https://hellogithub.com/periodical/statistics/click/?target=https://github.com/meolu/walle-web)：Walle（瓦力） 一个 Web 部署系统工具，可能也是个持续发布工具，配置简单、功能完善、界面流畅、开箱即用！支持 git、svn 版本管理，支持各种 Web 代码发布，静态的 HTML，动态 PHP，需要编译的 Java 等。[中文介绍](https://github.com/meolu/walle-web/blob/master/docs/README-zh.md)，使用展示如图：


<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img/master/hellogithub/03/img/wali-show.gif' style="max-width:80%; max-height=80%;"></img></p>

<p align="center"><a href="#目录">🔙 返回目录 🔙</a></p><br>

### Python 项目
8、[KindleEar](https://hellogithub.com/periodical/statistics/click/?target=https://github.com/cdhigh/KindleEar)：这是一个运行在 Google App Engine(GAE) 上的 Kindle 个人推送服务应用，生成排版精美的杂志模式 `mobi/epub` 格式自动每天推送至您的 Kindle 或其他邮箱。

<p align="center"><a href="#目录">🔙 返回目录 🔙</a></p><br>

### 其它
9、[css-creating](https://hellogithub.com/periodical/statistics/click/?target=https://github.com/cssdream/css-creating)：CSS 创作指南

<p align="center"><a href="#目录">🔙 返回目录 🔙</a></p><br>



<p align="center">
    <a href="https://github.com/521xueweihan/HelloGitHub/blob/master/content/02/HelloGitHub02.md">『上一期』</a> | <a href='https://github.com/521xueweihan/HelloGitHub/issues/673'>反馈和建议</a> | <a href="https://github.com/521xueweihan/HelloGitHub/blob/master/content/04/HelloGitHub04.md">『下一期』</a>
</p>

---
<p align="center">
    看完了，还不够？<a href='https://github.com/ruanyf/weekly'><科技爱好者周刊></a>。还不过瘾，那就看看每天更新的前端日报吧 <a href='https://daily.fairyever.com/'><今日前端></a><br>
    <a href='https://github.com/521xueweihan/HelloGitHub/issues/new'>点击分享发现的有趣项目</a>
</p>


## 声明
<a rel="license" href="https://creativecommons.org/licenses/by-nc-nd/4.0/deed.zh"><img alt="知识共享许可协议" style="border-width: 0" src="https://licensebuttons.net/l/by-nc-nd/4.0/88x31.png"></a><br>本作品采用 <a rel="license" href="https://creativecommons.org/licenses/by-nc-nd/4.0/deed.zh">署名-非商业性使用-禁止演绎 4.0 国际</a> 进行许可。
