# 《HelloGitHub》第 04 期
>兴趣是最好的老师，**HelloGitHub** 就是帮你找到兴趣！
<p align="center">
    <img src='https://raw.githubusercontent.com/521xueweihan/img/master/hellogithub/01/img/hello-github.jpg' style="max-width:100%;"></img>
</p>

## 简介
分享 GitHub 上有趣、入门级的开源项目。

这是一个面向**编程新手**、**热爱编程**、**对开源社区感兴趣** 人群的月刊，月刊的内容包括：**各种编程语言的项目**、**让生活变得更美好的工具**、**书籍、学习笔记、教程等**，这些开源项目大多都是非常容易上手，而且非常 Cool。主要是希望大家能动手用起来，加入到**开源社区**中。
- 会编程的可以贡献代码
- 不会编程的可以反馈使用这些工具中的 Bug
- 帮着宣传你觉得优秀的项目
- Star 项目⭐️

在浏览、参与这些项目的过程中，你将学习到**更多编程知识**、**提高编程技巧**、**找到编程的乐趣**。

🎉 最后 HelloGitHub 这个项目就诞生了 🎉

## 目录
- [Java 项目](#Java-项目)
- [JavaScript 项目](#JavaScript-项目)
- [Python 项目](#Python-项目)
- [其它](#其它)


<p align="center">
  <img src="https://raw.githubusercontent.com/521xueweihan/img/master/hellogithub/logo/weixin.png" style="max-width:30%;"></img><br>
欢迎关注 HelloGitHub 公众号，获取更多开源项目的资料和内容。
</p>

## 内容
> **以下为本期内容**｜每个月 **28** 号发布最新一期｜[官网](https://hellogithub.com/)

### Java 项目
1、[cachecloud](https://hellogithub.com/periodical/statistics/click/?target=https://github.com/sohutv/cachecloud)：搜狐视频开源的 CacheCloud 项目，提供了一个 Redis 云管理平台，功能强大，教程详细（有视频教程），文档齐全，**企业级开源项目**


<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img/master/hellogithub/04/img/cachecloud-min.png' style="max-width:80%; max-height=80%;"></img></p>

<p align="center"><a href="#目录">🔙 返回目录 🔙</a></p><br>

### JavaScript 项目
2、[zingtouch](https://hellogithub.com/periodical/statistics/click/?target=https://github.com/zingchart/zingtouch)：支持移动端各种触摸动作包含：转动、挥动、滑动等动作的库，[官方网站](https://zingchart.github.io/zingtouch/)，展示图如下：


<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img/master/hellogithub/04/img/zingtouch-show.gif' style="max-width:80%; max-height=80%;"></img></p>

3、[zhihudaily-vue](https://hellogithub.com/periodical/statistics/click/?target=https://github.com/yatessss/zhihudaily-vue)：用 Vue.js 写的知乎日报手机 Web 版，[展示](http://zhihudaily-vue.yatessss.com/)，需打开 chrome 浏览器的手机模拟功能，来获得比较好的浏览效果。访问展示图如下：


<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img/master/hellogithub/04/img/zhihu-vue-min.png' style="max-width:80%; max-height=80%;"></img></p>

<p align="center"><a href="#目录">🔙 返回目录 🔙</a></p><br>

### Python 项目
4、[python-guide](https://hellogithub.com/periodical/statistics/click/?target=https://github.com/kennethreitz/python-guide)：Requests 库的作者——kennethreitz，写的 Python 入门教程。不单单是语法层面的，涵盖项目结构、代码风格，进阶、工具等方方面面。虽然是**英文版**([中文翻译版](http://pythonguidecn.readthedocs.io/zh/latest/))，但我这个英语渣都能看懂，你肯定也可以，快去看看吧，开卷有益。[在线阅读](http://docs.python-guide.org/en/latest/)

5、[flask-admin](https://hellogithub.com/periodical/statistics/click/?target=https://github.com/flask-admin/flask-admin)：我工作中需要写一个微型的管理系统，用的就是这个框架。简直快餐型，页面都写好了，只要设置好相关配置就可以跑起来了。唯一缺点就是文档中的例子少，开发一些特定的需求需要自己看源码，才能知道如何改。[文档](https://flask-admin.readthedocs.io/en/latest/)，下面是我跑起来之后的样子：


<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img/master/hellogithub/04/img/flask-admin-show.gif' style="max-width:80%; max-height=80%;"></img></p>

6、[python-sdk](https://hellogithub.com/periodical/statistics/click/?target=https://github.com/qiniu/python-sdk)：七牛云存储 SDK。我自己在用他家的服务，上手简单、有免费额度，可以用来做‘图床’，同时，有了这个 SDK 可以写一些好用的小工具。**注意**：图床不能随便用，我曾经就用超了，账户的钱能扣成**负数**！

<p align="center"><a href="#目录">🔙 返回目录 🔙</a></p><br>

### 其它
7、[interview_python](https://hellogithub.com/periodical/statistics/click/?target=https://github.com/taizilongxu/interview_python)：关于 Python 的面试题

8、[PyZh](https://hellogithub.com/periodical/statistics/click/?target=https://github.com/MrKiven/PyZh)：Python 经典的技术文章的翻译和收集，[在线阅读](http://pyzh.readthedocs.io/en/latest/)

9、[interview](https://hellogithub.com/periodical/statistics/click/?target=https://github.com/HIT-Alibaba/interview)：笔试面试知识整理(涵盖：IOS、Android、计算机基础)，[在线阅读](https://hit-alibaba.github.io/interview/index.html)

10、[Front-end-Web-Development-Interview-Question](https://hellogithub.com/periodical/statistics/click/?target=https://github.com/paddingme/Front-end-Web-Development-Interview-Question)：前端开发面试题大收集

11、[AndroidInterview-Q-A](https://hellogithub.com/periodical/statistics/click/?target=https://github.com/JackyAndroid/AndroidInterview-Q-A)：这个项目主要是国内一线互联网公司的 Java 和 Android 方面的内部面试题。

12、[How-to-Be-A-Programmer-CN](https://hellogithub.com/periodical/statistics/click/?target=https://github.com/ahangchen/How-to-Be-A-Programmer-CN)：如何做好一枚程序员（中文翻译版）

13、[neural-networks-and-deep-learning](https://hellogithub.com/periodical/statistics/click/?target=https://github.com/mnielsen/neural-networks-and-deep-learning)：《神经网络与深度学习》相关代码 Python 实现，[神经网络与深度学习－中文在线阅读](https://tigerneil.gitbooks.io/neural-networks-and-deep-learning-zh/content/chapter1.html)，该书中的相关理论的 Python 代码实现

14、[awesome-mac](https://hellogithub.com/periodical/statistics/click/?target=https://github.com/jaywcjlove/awesome-mac)：排版相当好的一个 awesome 系列文章，文中介绍了很多 Mac 上好用的工具。

<p align="center"><a href="#目录">🔙 返回目录 🔙</a></p><br>



<p align="center">
    <a href="https://github.com/521xueweihan/HelloGitHub/blob/master/content/03/HelloGitHub03.md">『上一期』</a> | <a href='https://github.com/521xueweihan/HelloGitHub/issues/673'>反馈和建议</a> | <a href="https://github.com/521xueweihan/HelloGitHub/blob/master/content/05/HelloGitHub05.md">『下一期』</a>
</p>

---
<p align="center">
    看完了，还不够？<a href='https://github.com/ruanyf/weekly'><科技爱好者周刊></a>。还不过瘾，那就看看每天更新的前端日报吧 <a href='https://daily.fairyever.com/'><今日前端></a><br>
    <a href='https://github.com/521xueweihan/HelloGitHub/issues/new'>点击分享发现的有趣项目</a>
</p>


## 声明
<a rel="license" href="https://creativecommons.org/licenses/by-nc-nd/4.0/deed.zh"><img alt="知识共享许可协议" style="border-width: 0" src="https://licensebuttons.net/l/by-nc-nd/4.0/88x31.png"></a><br>本作品采用 <a rel="license" href="https://creativecommons.org/licenses/by-nc-nd/4.0/deed.zh">署名-非商业性使用-禁止演绎 4.0 国际</a> 进行许可。
