# 《HelloGitHub》第 17 期
>兴趣是最好的老师，**HelloGitHub** 就是帮你找到兴趣！
<p align="center">
    <img src='https://raw.githubusercontent.com/521xueweihan/img/master/hellogithub/01/img/hello-github.jpg' style="max-width:100%;"></img>
</p>

## 简介
分享 GitHub 上有趣、入门级的开源项目。

这是一个面向**编程新手**、**热爱编程**、**对开源社区感兴趣** 人群的月刊，月刊的内容包括：**各种编程语言的项目**、**让生活变得更美好的工具**、**书籍、学习笔记、教程等**，这些开源项目大多都是非常容易上手，而且非常 Cool。主要是希望大家能动手用起来，加入到**开源社区**中。
- 会编程的可以贡献代码
- 不会编程的可以反馈使用这些工具中的 Bug
- 帮着宣传你觉得优秀的项目
- Star 项目⭐️

在浏览、参与这些项目的过程中，你将学习到**更多编程知识**、**提高编程技巧**、**找到编程的乐趣**。

🎉 最后 HelloGitHub 这个项目就诞生了 🎉

## 目录
- [C# 项目](#C-项目)
- [CSS 项目](#CSS-项目)
- [Go 项目](#Go-项目)
- [Java 项目](#Java-项目)
- [JavaScript 项目](#JavaScript-项目)
- [Kotlin 项目](#Kotlin-项目)
- [Python 项目](#Python-项目)
- [其它](#其它)
- [开源书籍](#开源书籍)
- [机器学习](#机器学习)


<p align="center">
  <img src="https://raw.githubusercontent.com/521xueweihan/img/master/hellogithub/logo/weixin.png" style="max-width:30%;"></img><br>
欢迎关注 HelloGitHub 公众号，获取更多开源项目的资料和内容。
</p>

## 内容
> **以下为本期内容**｜每个月 **28** 号发布最新一期｜[官网](https://hellogithub.com/)

### C# 项目
1、[ASTool](https://hellogithub.com/periodical/statistics/click/?target=https://github.com/asheigithub/ASTool)：NET2.0 实现的 AS3（第三代 Flash 脚本）解释器，可用于嵌入 unity 做热更。一个完整的脚本语言解释执行系统，从语法树分析开始一直到实际执行

2、[MaterialDesignInXamlToolkit](https://hellogithub.com/periodical/statistics/click/?target=https://github.com/ButchersBoy/MaterialDesignInXamlToolkit)：谷歌 Material Design 设计风格控件库

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img/master/hellogithub/17/img/MaterialDesignInXamlToolkit-show-min.png' style="max-width:80%; max-height=80%;"></img></p>

<p align="center"><a href="#目录">🔙 返回目录 🔙</a></p><br>

### CSS 项目
3、[bulma](https://hellogithub.com/periodical/statistics/click/?target=https://github.com/jgthms/bulma)：UI框架，样式比 Bootstrap 更加扁平化。源码文件结构清晰，通过源码可以学到 UI 框架架构。[使用 bulma 的网站展示](http://bulma.io/expo/)

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img/master/hellogithub/17/img/bulma-show-min.png' style="max-width:80%; max-height=80%;"></img></p>

<p align="center"><a href="#目录">🔙 返回目录 🔙</a></p><br>

### Go 项目
4、[jwt-go](https://hellogithub.com/periodical/statistics/click/?target=https://github.com/dgrijalva/jwt-go)：Golang 实现 JSON Web Tokens (JWT)

5、[casbin](https://hellogithub.com/periodical/statistics/click/?target=https://github.com/casbin/casbin)：访问控制开源库，支持 ACL/RBAC/ABAC 等访问控制模型，支持 MySQL/NoSQL 等存储方式

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img/master/hellogithub/17/img/casbin-show-min.png' style="max-width:80%; max-height=80%;"></img></p>

<p align="center"><a href="#目录">🔙 返回目录 🔙</a></p><br>

### Java 项目
6、[GankMM](https://hellogithub.com/periodical/statistics/click/?target=https://github.com/maning0303/GankMM)：干货集中营 Android 客户端。每天一张美女图片，一个视频短片，若干Android，iOS等程序干货，周一到周五每天更新，数据全部由 [干货集中营](http://gank.io/) 提供。项目简单完整，涉及内容全面，利于学习 Android 开发的技巧

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img/master/hellogithub/17/img/GankMM.gif' style="max-width:80%; max-height=80%;"></img></p>

7、[MVPArms](https://hellogithub.com/periodical/statistics/click/?target=https://github.com/JessYanCoding/MVPArms)：整合了大量主流开源项目的 Android Mvp 快速搭建框架。包含 Dagger2、Retrofit、Rxjava 等 Rx 系三方库，并且提供 UI 自适应方案，本框架将它们结合起来。文档详尽、成熟稳定的 Android MVP 解决方案

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img/master/hellogithub/17/img/MVPArms-show-min.png' style="max-width:80%; max-height=80%;"></img></p>

8、[elasticsearch-sql](https://hellogithub.com/periodical/statistics/click/?target=https://github.com/NLPchina/elasticsearch-sql)：用 SQL 查询 Elasticsearch

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img/master/hellogithub/17/img/elasticsearch-sql-show-min.png' style="max-width:80%; max-height=80%;"></img></p>

<p align="center"><a href="#目录">🔙 返回目录 🔙</a></p><br>

### JavaScript 项目
9、[gka](https://hellogithub.com/periodical/statistics/click/?target=https://github.com/gkajs/gka)：简单、高效的帧动画生成工具，图片处理工具。
- 一键式：图片文件批量序列化重命名，生成帧动画文件，支持预览
- 性能佳：支持相同帧图片复用✓，图片空白裁剪✓，合图模式✓，图片压缩✓
- 多模板：内置多种文件输出模板，支持自定义模板

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img/master/hellogithub/17/img/gka.gif' style="max-width:80%; max-height=80%;"></img></p>

10、[sweetalert](https://hellogithub.com/periodical/statistics/click/?target=https://github.com/t4t5/sweetalert)：纯 JS 写成的 alert 组件，很多公司都在使用的项目。源代码使用了 ES6 进行了重构，使得项目结构更加清晰。可以通过学习其项目结构可以更好的了解 JS 组件的文件结构，分析其源码可以学习如何使用原生 JS 操作 DOM 的高级技巧

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img/master/hellogithub/17/img/sweetalert.gif' style="max-width:80%; max-height=80%;"></img></p>

11、[trust](https://hellogithub.com/periodical/statistics/click/?target=https://github.com/ncase/trust)：一个合作博弈论的互动讲解手册，[中文版在线试玩](https://www.sekai.co/trust/)

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img/master/hellogithub/17/img/trust-show-min.png' style="max-width:80%; max-height=80%;"></img></p>

12、[wtfjs](https://hellogithub.com/periodical/statistics/click/?target=https://github.com/denysdovhan/wtfjs)：JavaScript 有趣和棘手（坑爹？）的示例

13、[parrot-mocker-web](https://hellogithub.com/periodical/statistics/click/?target=https://github.com/chinesedfan/parrot-mocker-web)：小巧的 mock 服务器，配合 Chrome 插件可以轻松地拦截或 mock 页面上的 xhr/jsonp/fetch 请求。不需要侵入页面本身代码，让前端同学在后端接口没有 ready 或者难以模拟数据的时候，继续开心地开发玩耍

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img/master/hellogithub/17/img/parrot-mocker-web-show-min.png' style="max-width:80%; max-height=80%;"></img></p>

<p align="center"><a href="#目录">🔙 返回目录 🔙</a></p><br>

### Kotlin 项目
14、[Eyepetizer-in-Kotlin](https://hellogithub.com/periodical/statistics/click/?target=https://github.com/LRH1993/Eyepetizer-in-Kotlin)：一款使用 kotlin 语言开发的 App。适合初学者作为学习 kotlin 语言的一个项目，可以在做项目的同时体验到 kotlin 语言的优点

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img/master/hellogithub/17/img/Eyepetizer-in-Kotlin-show-min.png' style="max-width:80%; max-height=80%;"></img></p>

<p align="center"><a href="#目录">🔙 返回目录 🔙</a></p><br>

### Python 项目
15、[huey](https://hellogithub.com/periodical/statistics/click/?target=https://github.com/coleifer/huey)：结合 redis 实现的轻量任务队列，但是支持功能还是很多的：
- 多进程、多线程、协程
- 任务定时执行
- 任务执行失败重试
- 结果存储

16、[simiki](https://hellogithub.com/periodical/statistics/click/?target=https://github.com/tankywoo/simiki)：一个简单的个人 Wiki 框架，便于快速搭建 Wiki 页。使用 Markdown 书写 Wiki, 生成静态 HTML 页面。Wiki 源文件按目录分类存放, 方便管理维护。[中文文档](http://simiki.org/zh-docs/)

17、[pyecharts](https://hellogithub.com/periodical/statistics/click/?target=https://github.com/chenjiandongx/pyecharts)：Echarts+Python 实现的一个用于生成 Echarts 图表的类库

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img/master/hellogithub/17/img/pyecharts.gif' style="max-width:80%; max-height=80%;"></img></p>

18、[proxy_pool](https://hellogithub.com/periodical/statistics/click/?target=https://github.com/jhao104/proxy_pool)：基于 Python 的自建代理 IP 池服务，通过网络爬虫抓取互联网上免费的代理 IP，本地校验、剔除失效的代理IP，从而实现高可用的代理 IP 池。最后使用 Flask 搭建提供代理 IP 服务，包括代理池刷新、无效代理删除、代理获取等。该项目设计文档详细、模块结构简明易懂，同时适合爬虫新手更好的学习爬虫技术

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img/master/hellogithub/17/img/proxy_pool-show-min.png' style="max-width:80%; max-height=80%;"></img></p>

19、[WeiboSpider](https://hellogithub.com/periodical/statistics/click/?target=https://github.com/ResolveWang/WeiboSpider)：分布式微博爬虫，支持快速抓取和稳定抓取两种运行模式。项目模块逻辑清晰、注释丰富、便于定制化自己的需求。同时，对于小白用户，可以通过演示视频快速入门，也提供QQ群答疑，已经持续维护一年多。靠谱的项目，小伙伴们要赶快上车～

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img/master/hellogithub/17/img/WeiboSpider-show-min.png' style="max-width:80%; max-height=80%;"></img></p>

<p align="center"><a href="#目录">🔙 返回目录 🔙</a></p><br>

### 其它
20、[Material-Design-Chinese](https://hellogithub.com/periodical/statistics/click/?target=https://github.com/zdhxiong/Material-Design-Chinese)：Material Design 官方文档的中文翻译，保留了原版网站的样式，并保持和官方文档同步更新

21、[sec-chart](https://hellogithub.com/periodical/statistics/click/?target=https://github.com/SecWiki/sec-chart)：安全思维导图集合

22、[learn-regex](https://hellogithub.com/periodical/statistics/click/?target=https://github.com/zeeshanu/learn-regex)：易学的正则表达式教程，[中文](https://github.com/zeeshanu/learn-regex/blob/master/README-cn.md)

23、[games](https://hellogithub.com/periodical/statistics/click/?target=https://github.com/leereilly/games)：GitHub 上游戏项目的合集

24、[PythonSpiderNotes](https://hellogithub.com/periodical/statistics/click/?target=https://github.com/lining0806/PythonSpiderNotes)：Python 爬虫入门教程

<p align="center"><a href="#目录">🔙 返回目录 🔙</a></p><br>

### 开源书籍
25、[pandas-cookbook](https://hellogithub.com/periodical/statistics/click/?target=https://github.com/jvns/pandas-cookbook)：pandas cookbook（英文）

26、[tensorflow_cookbook](https://hellogithub.com/periodical/statistics/click/?target=https://github.com/nfmcclure/tensorflow_cookbook)：Tensorflow cookbook（英文）

<p align="center"><a href="#目录">🔙 返回目录 🔙</a></p><br>

### 机器学习
27、[TensorFlow-World](https://hellogithub.com/periodical/statistics/click/?target=https://github.com/astorfi/TensorFlow-World)：简单易用的 TensorFlow 教程

28、[EffectiveTensorflow](https://hellogithub.com/periodical/statistics/click/?target=https://github.com/vahidk/EffectiveTensorflow)：TensorFlow 最佳实践

<p align="center"><a href="#目录">🔙 返回目录 🔙</a></p><br>



<p align="center">
    <a href="https://github.com/521xueweihan/HelloGitHub/blob/master/content/16/HelloGitHub16.md">『上一期』</a> | <a href='https://github.com/521xueweihan/HelloGitHub/issues/673'>反馈和建议</a> | <a href="https://github.com/521xueweihan/HelloGitHub/blob/master/content/18/HelloGitHub18.md">『下一期』</a>
</p>

---
<p align="center">
    看完了，还不够？<a href='https://github.com/ruanyf/weekly'><科技爱好者周刊></a>。还不过瘾，那就看看每天更新的前端日报吧 <a href='https://daily.fairyever.com/'><今日前端></a><br>
    <a href='https://github.com/521xueweihan/HelloGitHub/issues/new'>点击分享发现的有趣项目</a>
</p>


## 声明
<a rel="license" href="https://creativecommons.org/licenses/by-nc-nd/4.0/deed.zh"><img alt="知识共享许可协议" style="border-width: 0" src="https://licensebuttons.net/l/by-nc-nd/4.0/88x31.png"></a><br>本作品采用 <a rel="license" href="https://creativecommons.org/licenses/by-nc-nd/4.0/deed.zh">署名-非商业性使用-禁止演绎 4.0 国际</a> 进行许可。
